Home | Namespaces | Hierarchy | Alphabetical List | Class list | Files | Namespace Members | Class members | File members | Tutorials

# irr::video::IVideoDriver Class Reference

Interface to driver which is able to perform 2d and 3d graphics functions. More...

`#include <IVideoDriver.h>`

Inheritance diagram for irr::video::IVideoDriver:

List of all members.

## Public Member Functions
virtual s32 | addDynamicLight (const SLight &light)=0
virtual void | addExternalImageLoader (IImageLoader *loader)=0
| Adds an external image loader to the engine.
virtual void | addExternalImageWriter (IImageWriter *writer)=0
| Adds an external image writer to the engine.
virtual s32 | addMaterialRenderer (IMaterialRenderer *renderer, const c8 *name=0)=0
| Adds a new material renderer to the video device.
virtual ITexture * | addRenderTargetTexture (const core::dimension2d< u32 > &size, const io::path &name="rt", const ECOLOR_FORMAT format=ECF_UNKNOWN)=0
| Adds a new render target texture to the texture cache.
virtual ITexture * | addTexture (const io::path &name, IImage *image)=0
| Creates a texture from an IImage.
virtual ITexture * | addTexture (const core::dimension2d< u32 > &size, const io::path &name, ECOLOR_FORMAT format=ECF_A8R8G8B8)=0
| Creates an empty texture of specified size.
virtual bool | beginScene (bool backBuffer=true, bool zBuffer=true, SColor color=SColor(255, 0, 0, 0), void *windowId=0, core::rect< s32 > *sourceRect=0)=0
| Applications must call this method before performing any rendering.
virtual bool | checkDriverReset ()=0
| Check if the driver was recently reset.
virtual void | clearZBuffer ()=0
| Clears the ZBuffer.
virtual io::IAttributes * | createAttributesFromMaterial (const video::SMaterial &material)=0
| Creates material attributes list from a material.
virtual IImage * | createImage (ITexture *texture, const core::position2d< s32 > &pos, const core::dimension2d< u32 > &size)=0
| Creates a software image from a part of a texture.
virtual IImage * | createImage (IImage *imageToCopy, const core::position2d< s32 > &pos, const core::dimension2d< u32 > &size)=0
| Creates a software image from a part of another image.
virtual IImage * | createImage (ECOLOR_FORMAT format, IImage *imageToCopy)=0
| Creates a software image by converting it to given format from another image.
virtual IImage * | createImage (ECOLOR_FORMAT format, const core::dimension2d< u32 > &size)=0
| Creates an empty software image.
virtual IImage * | createImageFromData (ECOLOR_FORMAT format, const core::dimension2d< u32 > &size, void *data, bool ownForeignMemory=false, bool deleteMemory=true)=0
| Creates a software image from a byte array.
virtual IImage * | createImageFromFile (io::IReadFile *file)=0
| Creates a software image from a file.
virtual IImage * | createImageFromFile (const io::path &filename)=0
| Creates a software image from a file.
virtual IImage * | createScreenShot ()=0
| Make a screenshot of the last rendered frame.
virtual void | deleteAllDynamicLights ()=0
| Deletes all dynamic lights which were previously added with addDynamicLight().
virtual void | disableFeature (E_VIDEO_DRIVER_FEATURE feature, bool flag=true)=0
| Disable a feature of the driver.
virtual void | draw2DImage (const video::ITexture *texture, const core::rect< s32 > &destRect, const core::rect< s32 > &sourceRect, const core::rect< s32 > *clipRect=0, const video::SColor *const colors=0, bool useAlphaChannelOfTexture=false)=0
| Draws a part of the texture into the rectangle. Note that colors must be an array of 4 colors if used.
virtual void | draw2DImage (const video::ITexture *texture, const core::position2d< s32 > &destPos, const core::rect< s32 > &sourceRect, const core::rect< s32 > *clipRect=0, SColor color=SColor(255, 255, 255, 255), bool useAlphaChannelOfTexture=false)=0
| Draws a 2d image using a color.
virtual void | draw2DImage (const video::ITexture *texture, const core::position2d< s32 > &destPos)=0
| Draws a 2d image without any special effects.
virtual void | draw2DImageBatch (const video::ITexture *texture, const core::array< core::position2d< s32 > > &positions, const core::array< core::rect< s32 > > &sourceRects, const core::rect< s32 > *clipRect=0, SColor color=SColor(255, 255, 255, 255), bool useAlphaChannelOfTexture=false)=0
| Draws a set of 2d images, using a color and the alpha channel of the texture.
virtual void | draw2DImageBatch (const video::ITexture *texture, const core::position2d< s32 > &pos, const core::array< core::rect< s32 > > &sourceRects, const core::array< s32 > &indices, s32 kerningWidth=0, const core::rect< s32 > *clipRect=0, SColor color=SColor(255, 255, 255, 255), bool useAlphaChannelOfTexture=false)=0
| Draws a set of 2d images, using a color and the alpha channel of the texture.
virtual void | draw2DLine (const core::position2d< s32 > &start, const core::position2d< s32 > &end, SColor color=SColor(255, 255, 255, 255))=0
| Draws a 2d line.
virtual void | draw2DPolygon (core::position2d< s32 > center, f32 radius, video::SColor color=SColor(100, 255, 255, 255), s32 vertexCount=10)=0
| Draws a non filled concyclic regular 2d polyon.
virtual void | draw2DRectangle (const core::rect< s32 > &pos, SColor colorLeftUp, SColor colorRightUp, SColor colorLeftDown, SColor colorRightDown, const core::rect< s32 > *clip=0)=0
| Draws a 2d rectangle with a gradient.
virtual void | draw2DRectangle (SColor color, const core::rect< s32 > &pos, const core::rect< s32 > *clip=0)=0
| Draws a 2d rectangle.
virtual void | draw2DRectangleOutline (const core::recti &pos, SColor color=SColor(255, 255, 255, 255))=0
| Draws the outline of a 2D rectangle.
virtual void | draw2DVertexPrimitiveList (const void *vertices, u32 vertexCount, const void *indexList, u32 primCount, E_VERTEX_TYPE vType=EVT_STANDARD, scene::E_PRIMITIVE_TYPE pType=scene::EPT_TRIANGLES, E_INDEX_TYPE iType=EIT_16BIT)=0
| Draws a vertex primitive list in 2d.
virtual void | draw3DBox (const core::aabbox3d< f32 > &box, SColor color=SColor(255, 255, 255, 255))=0
| Draws a 3d axis aligned box.
virtual void | draw3DLine (const core::vector3df &start, const core::vector3df &end, SColor color=SColor(255, 255, 255, 255))=0
| Draws a 3d line.
virtual void | draw3DTriangle (const core::triangle3df &triangle, SColor color=SColor(255, 255, 255, 255))=0
| Draws a 3d triangle.
virtual void | drawIndexedTriangleFan (const S3DVertex2TCoords *vertices, u32 vertexCount, const u16 *indexList, u32 triangleCount)=0
| Draws an indexed triangle fan.
virtual void | drawIndexedTriangleFan (const S3DVertex *vertices, u32 vertexCount, const u16 *indexList, u32 triangleCount)=0
| Draws an indexed triangle fan.
virtual void | drawIndexedTriangleList (const S3DVertexTangents *vertices, u32 vertexCount, const u16 *indexList, u32 triangleCount)=0
| Draws an indexed triangle list.
virtual void | drawIndexedTriangleList (const S3DVertex2TCoords *vertices, u32 vertexCount, const u16 *indexList, u32 triangleCount)=0
| Draws an indexed triangle list.
virtual void | drawIndexedTriangleList (const S3DVertex *vertices, u32 vertexCount, const u16 *indexList, u32 triangleCount)=0
| Draws an indexed triangle list.
virtual void | drawMeshBuffer (const scene::IMeshBuffer *mb)=0
| Draws a mesh buffer.
virtual void | drawPixel (u32 x, u32 y, const SColor &color)=0
| Draws a pixel.
virtual void | drawStencilShadow (bool clearStencilBuffer=false, video::SColor leftUpEdge=video::SColor(255, 0, 0, 0), video::SColor rightUpEdge=video::SColor(255, 0, 0, 0), video::SColor leftDownEdge=video::SColor(255, 0, 0, 0), video::SColor rightDownEdge=video::SColor(255, 0, 0, 0))=0
| Fills the stencil shadow with color.
virtual void | drawStencilShadowVolume (const core::vector3df *triangles, s32 count, bool zfail=true)=0
| Draws a shadow volume into the stencil buffer.
virtual void | drawVertexPrimitiveList (const void *vertices, u32 vertexCount, const void *indexList, u32 primCount, E_VERTEX_TYPE vType=EVT_STANDARD, scene::E_PRIMITIVE_TYPE pType=scene::EPT_TRIANGLES, E_INDEX_TYPE iType=EIT_16BIT)=0
| Draws a vertex primitive list.
virtual void | enableClipPlane (u32 index, bool enable)=0
| Enable or disable a clipping plane.
virtual bool | endScene ()=0
| Presents the rendered image to the screen.
virtual void | fillMaterialStructureFromAttributes (video::SMaterial &outMaterial, io::IAttributes *attributes)=0
| Fills an SMaterial structure from attributes.
virtual video::ITexture * | findTexture (const io::path &filename)=0
| Check if the image is already loaded.
virtual ECOLOR_FORMAT | getColorFormat () const =0
| Get the current color format of the color buffer.
virtual const core::dimension2d< u32 > & | getCurrentRenderTargetSize () const =0
| Get the size of the current render target.
virtual E_DRIVER_TYPE | getDriverType () const =0
| Get type of video driver.
virtual const SLight & | getDynamicLight (u32 idx) const =0
| Returns light data which was previously set by IVideoDriver::addDynamicLight().
virtual u32 | getDynamicLightCount () const =0
| Returns amount of dynamic lights currently set.
virtual const SExposedVideoData & | getExposedVideoData ()=0
| Returns driver and operating system specific data about the IVideoDriver.
virtual s32 | getFPS () const =0
| Returns current frames per second value.
virtual IGPUProgrammingServices * | getGPUProgrammingServices ()=0
| Gets the IGPUProgrammingServices interface.
virtual IImageLoader * | getImageLoader (u32 n)=0
| Retrieve the given image loader.
virtual u32 | getImageLoaderCount () const =0
| Retrieve the number of image loaders.
virtual IImageWriter * | getImageWriter (u32 n)=0
| Retrieve the given image writer.
virtual u32 | getImageWriterCount () const =0
| Retrieve the number of image writers.
virtual IMaterialRenderer * | getMaterialRenderer (u32 idx)=0
| Get access to a material renderer by index.
virtual u32 | getMaterialRendererCount () const =0
| Get amount of currently available material renderers.
virtual const c8 * | getMaterialRendererName (u32 idx) const =0
| Get name of a material renderer.
virtual u32 | getMaximalDynamicLightAmount () const =0
| Returns the maximal amount of dynamic lights the device can handle.
virtual u32 | getMaximalPrimitiveCount () const =0
| Returns the maximum amount of primitives.
virtual scene::IMeshManipulator * | getMeshManipulator ()=0
| Returns a pointer to the mesh manipulator.
virtual const wchar_t * | getName () const =0
| Gets name of this video driver.
virtual SOverrideMaterial & | getOverrideMaterial ()=0
| Get the global Material, which might override local materials.
virtual u32 | getPrimitiveCountDrawn (u32 mode=0) const =0
| Returns amount of primitives (mostly triangles) which were drawn in the last frame.
virtual const core::dimension2d< u32 > & | getScreenSize () const =0
| Get the size of the screen or render window.
virtual ITexture * | getTexture (io::IReadFile *file)=0
| Get access to a named texture.
virtual ITexture * | getTexture (const io::path &filename)=0
| Get access to a named texture.
virtual ITexture * | getTextureByIndex (u32 index)=0
| Returns a texture by index.
virtual u32 | getTextureCount () const =0
| Returns amount of textures currently loaded.
virtual bool | getTextureCreationFlag (E_TEXTURE_CREATION_FLAG flag) const =0
| Returns if a texture creation flag is enabled or disabled.
virtual const core::matrix4 & | getTransform (E_TRANSFORMATION_STATE state) const =0
| Returns the transformation set by setTransform.
virtual core::stringc | getVendorInfo ()=0
| Returns the graphics card vendor name.
virtual const core::rect< s32 > & | getViewPort () const =0
| Gets the area of the current viewport.
virtual void | makeColorKeyTexture (video::ITexture *texture, core::position2d< s32 > colorKeyPixelPos, bool zeroTexels=false) const =0
| Sets a boolean alpha channel on the texture based on the color at a position.
virtual void | makeColorKeyTexture (video::ITexture *texture, video::SColor color, bool zeroTexels=false) const =0
| Sets a boolean alpha channel on the texture based on a color key.
virtual void | makeNormalMapTexture (video::ITexture *texture, f32 amplitude=1.0f) const =0
| Creates a normal map from a height map texture.
virtual void | OnResize (const core::dimension2d< u32 > &size)=0
| Event handler for resize events. Only used by the engine internally.
virtual bool | queryFeature (E_VIDEO_DRIVER_FEATURE feature) const =0
| Queries the features of the driver.
virtual void | removeAllHardwareBuffers ()=0
| Remove all hardware buffers.
virtual void | removeAllTextures ()=0
| Removes all textures from the texture cache and deletes them.
virtual void | removeHardwareBuffer (const scene::IMeshBuffer *mb)=0
| Remove hardware buffer.
virtual void | removeTexture (ITexture *texture)=0
| Removes a texture from the texture cache and deletes it.
virtual void | renameTexture (ITexture *texture, const io::path &newName)=0
| Renames a texture.
virtual void | setAllowZWriteOnTransparent (bool flag)=0
| Only used by the engine internally.
virtual void | setAmbientLight (const SColorf &color)=0
| Only used by the engine internally.
virtual bool | setClipPlane (u32 index, const core::plane3df &plane, bool enable=false)=0
| Set or unset a clipping plane.
virtual void | setFog (SColor color=SColor(0, 255, 255, 255), E_FOG_TYPE fogType=EFT_FOG_LINEAR, f32 start=50.0f, f32 end=100.0f, f32 density=0.01f, bool pixelFog=false, bool rangeFog=false)=0
| Sets the fog mode.
virtual void | setMaterial (const SMaterial &material)=0
| Sets a material.
virtual void | setMaterialRendererName (s32 idx, const c8 *name)=0
| Sets the name of a material renderer.
virtual void | setMinHardwareBufferVertexCount (u32 count)=0
| Set the minimum number of vertices for which a hw buffer will be created.
virtual bool | setRenderTarget (E_RENDER_TARGET target, bool clearTarget=true, bool clearZBuffer=true, SColor color=video::SColor(0, 0, 0, 0))=0
| set or reset special render targets
virtual bool | setRenderTarget (video::ITexture *texture, bool clearBackBuffer=true, bool clearZBuffer=true, SColor color=video::SColor(0, 0, 0, 0))=0
| Sets a new render target.
virtual void | setTextureCreationFlag (E_TEXTURE_CREATION_FLAG flag, bool enabled=true)=0
| Enables or disables a texture creation flag.
virtual void | setTransform (E_TRANSFORMATION_STATE state, const core::matrix4 &mat)=0
| Sets transformation matrices.
virtual void | setViewPort (const core::rect< s32 > &area)=0
| Sets a new viewport.
virtual void | turnLightOn (s32 lightIndex, bool turnOn)=0
virtual bool | writeImageToFile (IImage *image, io::IWriteFile *file, u32 param=0)=0
| Writes the provided image to a file.
virtual bool | writeImageToFile (IImage *image, const io::path &filename, u32 param=0)=0
| Writes the provided image to a file.

## Detailed Description

Interface to driver which is able to perform 2d and 3d graphics functions.

This interface is one of the most important interfaces of the Irrlicht Engine: All rendering and texture manipulation is done with this interface. You are able to use the Irrlicht Engine by only invoking methods of this interface if you like to, although the irr::scene::ISceneManager interface provides a lot of powerful classes and methods to make the programmer's life easier.

Definition at line 197 of file IVideoDriver.h.

## Member Function Documentation

virtual s32 irr::video::IVideoDriver::addDynamicLight | ( | const SLight & | light | ) | `[pure virtual]`

adds a dynamic light, returning an index to the light

Parameters:

  | light,: | the light data to use to create the light

Returns:
  An index to the light, or -1 if an error occurs

virtual void irr::video::IVideoDriver::addExternalImageLoader | ( | IImageLoader * | loader | ) | `[pure virtual]`

Adds an external image loader to the engine.

This is useful if the Irrlicht Engine should be able to load textures of currently unsupported file formats (e.g. gif). The IImageLoader only needs to be implemented for loading this file format. A pointer to the implementation can be passed to the engine using this method.

Parameters:

  | loader | Pointer to the external loader created.

virtual void irr::video::IVideoDriver::addExternalImageWriter | ( | IImageWriter * | writer | ) | `[pure virtual]`

Adds an external image writer to the engine.

This is useful if the Irrlicht Engine should be able to write textures of currently unsupported file formats (e.g .gif). The IImageWriter only needs to be implemented for writing this file format. A pointer to the implementation can be passed to the engine using this method.

Parameters:

  | writer,: | Pointer to the external writer created.

virtual s32 irr::video::IVideoDriver::addMaterialRenderer | ( | IMaterialRenderer * | renderer,
|  | const c8 * | name = `0` |
| ) |  |  | `[pure virtual]`

Adds a new material renderer to the video device.

Use this method to extend the VideoDriver with new material types. To extend the engine using this method do the following: Derive a class from IMaterialRenderer and override the methods you need. For setting the right renderstates, you can try to get a pointer to the real rendering device using IVideoDriver::getExposedVideoData(). Add your class with IVideoDriver::addMaterialRenderer(). To use an object being displayed with your new material, set the MaterialType member of the SMaterial struct to the value returned by this method. If you simply want to create a new material using vertex and/or pixel shaders it would be easier to use the video::IGPUProgrammingServices interface which you can get using the getGPUProgrammingServices() method.

Parameters:

  | renderer | A pointer to the new renderer.
  | name | Optional name for the material renderer entry.

Returns:
  The number of the material type which can be set in SMaterial::MaterialType to use the renderer. -1 is returned if an error occured. For example if you tried to add an material renderer to the software renderer or the null device, which do not accept material renderers.

virtual ITexture* irr::video::IVideoDriver::addRenderTargetTexture | ( | const core::dimension2d< u32 > & | size,
|  | const io::path & | name = `"rt"`,
|  | const ECOLOR_FORMAT | format = `ECF_UNKNOWN` |
| ) |  |  | `[pure virtual]`

Adds a new render target texture to the texture cache.

Parameters:

  | size | Size of the texture, in pixels. Width and height should be a power of two (e.g. 64, 128, 256, 512, ...) and it should not be bigger than the backbuffer, because it shares the zbuffer with the screen buffer.
  | name | An optional name for the RTT.
  | format | The color format of the render target. Floating point formats are supported.

Returns:
  Pointer to the created texture or 0 if the texture could not be created. This pointer should not be dropped. See IReferenceCounted::drop() for more information.

virtual ITexture* irr::video::IVideoDriver::addTexture | ( | const io::path & | name,
|  | IImage * | image |
| ) |  |  | `[pure virtual]`

Creates a texture from an IImage.

Parameters:

  | name | A name for the texture. Later calls of getTexture() with this name will return this texture
  | image | Image the texture is created from.

Returns:
  Pointer to the newly created texture. This pointer should not be dropped. See IReferenceCounted::drop() for more information.

virtual ITexture* irr::video::IVideoDriver::addTexture | ( | const core::dimension2d< u32 > & | size,
|  | const io::path & | name,
|  | ECOLOR_FORMAT | format = `ECF_A8R8G8B8` |
| ) |  |  | `[pure virtual]`

Creates an empty texture of specified size.

Parameters:

  | size,: | Size of the texture.
  | name | A name for the texture. Later calls to getTexture() with this name will return this texture
  | format | Desired color format of the texture. Please note that the driver may choose to create the texture in another color format.

Returns:
  Pointer to the newly created texture. This pointer should not be dropped. See IReferenceCounted::drop() for more information.

Referenced by irr::scene::quake3::getTextures().

virtual bool irr::video::IVideoDriver::beginScene | ( | bool | backBuffer = `true`,
|  | bool | zBuffer = `true`,
|  | SColor | color = `SColor(255, 0, 0, 0)`,
|  | void * | windowId = `0`,
|  | core::rect< s32 > * | sourceRect = `0` |
| ) |  |  | `[pure virtual]`

Applications must call this method before performing any rendering.

This method can clear the back- and the z-buffer.

Parameters:

  | backBuffer | Specifies if the back buffer should be cleared, which means that the screen is filled with the color specified. If this parameter is false, the back buffer will not be cleared and the color parameter is ignored.
  | zBuffer | Specifies if the depth buffer (z buffer) should be cleared. It is not nesesarry to do so if only 2d drawing is used.
  | color | The color used for back buffer clearing
  | windowId | Handle of another window, if you want the bitmap to be displayed on another window. If this is null, everything will be displayed in the default window. Note: This feature is not fully implemented for all devices.
  | sourceRect | Pointer to a rectangle defining the source rectangle of the area to be presented. Set to null to present everything. Note: not implemented in all devices.

Returns:
  False if failed.

virtual bool irr::video::IVideoDriver::checkDriverReset | ( |  | ) | `[pure virtual]`

Check if the driver was recently reset.

For d3d devices you will need to recreate the RTTs if the driver was reset. Should be queried right after beginScene().

virtual void irr::video::IVideoDriver::clearZBuffer | ( |  | ) | `[pure virtual]`

Clears the ZBuffer.

Note that you usually need not to call this method, as it is automatically done in IVideoDriver::beginScene() or IVideoDriver::setRenderTarget() if you enable zBuffer. But if you have to render some special things, you can clear the zbuffer during the rendering process with this method any time.

virtual io::IAttributes* irr::video::IVideoDriver::createAttributesFromMaterial | ( | const video::SMaterial & | material | ) | `[pure virtual]`

Creates material attributes list from a material.

This method is useful for serialization and more. Please note that the video driver will use the material renderer names from getMaterialRendererName() to write out the material type name, so they should be set before.

Parameters:

  | material | The material to serialize.

Returns:
  The io::IAttributes container holding the material properties.

virtual IImage* irr::video::IVideoDriver::createImage | ( | ITexture * | texture,
|  | const core::position2d< s32 > & | pos,
|  | const core::dimension2d< u32 > & | size |
| ) |  |  | `[pure virtual]`

Creates a software image from a part of a texture.

Parameters:

  | texture | Texture to copy to the new image in part.
  | pos | Position of rectangle to copy.
  | size | Extents of rectangle to copy.

Returns:
  The created image. If you no longer need the image, you should call IImage::drop(). See IReferenceCounted::drop() for more information.

virtual IImage* irr::video::IVideoDriver::createImage | ( | IImage * | imageToCopy,
|  | const core::position2d< s32 > & | pos,
|  | const core::dimension2d< u32 > & | size |
| ) |  |  | `[pure virtual]`

Creates a software image from a part of another image.

Parameters:

  | imageToCopy | Image to copy to the new image in part.
  | pos | Position of rectangle to copy.
  | size | Extents of rectangle to copy.

Returns:
  The created image. If you no longer need the image, you should call IImage::drop(). See IReferenceCounted::drop() for more information.

virtual IImage* irr::video::IVideoDriver::createImage | ( | ECOLOR_FORMAT | format,
|  | IImage * | imageToCopy |
| ) |  |  | `[pure virtual]`

Creates a software image by converting it to given format from another image.

Parameters:

  | format | Desired color format of the image.
  | imageToCopy | Image to copy to the new image.

Returns:
  The created image. If you no longer need the image, you should call IImage::drop(). See IReferenceCounted::drop() for more information.

virtual IImage* irr::video::IVideoDriver::createImage | ( | ECOLOR_FORMAT | format,
|  | const core::dimension2d< u32 > & | size |
| ) |  |  | `[pure virtual]`

Creates an empty software image.

Parameters:

  | format | Desired color format of the image.
  | size | Size of the image to create.

Returns:
  The created image. If you no longer need the image, you should call IImage::drop(). See IReferenceCounted::drop() for more information.

virtual IImage* irr::video::IVideoDriver::createImageFromData | ( | ECOLOR_FORMAT | format,
|  | const core::dimension2d< u32 > & | size,
|  | void * | data,
|  | bool | ownForeignMemory = `false`,
|  | bool | deleteMemory = `true` |
| ) |  |  | `[pure virtual]`

Creates a software image from a byte array.

No hardware texture will be created for this image. This method is useful for example if you want to read a heightmap for a terrain renderer.

Parameters:

  | format | Desired color format of the texture
  | size | Desired size of the image
  | data | A byte array with pixel color information
  | ownForeignMemory | If true, the image will use the data pointer directly and own it afterwards. If false, the memory will by copied internally.
  | deleteMemory | Whether the memory is deallocated upon destruction.

Returns:
  The created image. If you no longer need the image, you should call IImage::drop(). See IReferenceCounted::drop() for more information.

Referenced by irr::scene::quake3::getTextures().

virtual IImage* irr::video::IVideoDriver::createImageFromFile | ( | io::IReadFile * | file | ) | `[pure virtual]`

Creates a software image from a file.

No hardware texture will be created for this image. This method is useful for example if you want to read a heightmap for a terrain renderer.

Parameters:

  | file | File from which the image is created.

Returns:
  The created image. If you no longer need the image, you should call IImage::drop(). See IReferenceCounted::drop() for more information.

virtual IImage* irr::video::IVideoDriver::createImageFromFile | ( | const io::path & | filename | ) | `[pure virtual]`

Creates a software image from a file.

No hardware texture will be created for this image. This method is useful for example if you want to read a heightmap for a terrain renderer.

Parameters:

  | filename | Name of the file from which the image is created.

Returns:
  The created image. If you no longer need the image, you should call IImage::drop(). See IReferenceCounted::drop() for more information.

virtual IImage* irr::video::IVideoDriver::createScreenShot | ( |  | ) | `[pure virtual]`

Make a screenshot of the last rendered frame.

Returns:
  An image created from the last rendered frame.

virtual void irr::video::IVideoDriver::deleteAllDynamicLights | ( |  | ) | `[pure virtual]`

Deletes all dynamic lights which were previously added with addDynamicLight().

virtual void irr::video::IVideoDriver::disableFeature | ( | E_VIDEO_DRIVER_FEATURE | feature,
|  | bool | flag = `true` |
| ) |  |  | `[pure virtual]`

Disable a feature of the driver.

Can also be used to enable the features again. It is not possible to enable unsupported features this way, though.

Parameters:

  | feature | Feature to disable.
  | flag | When true the feature is disabled, otherwise it is enabled.

virtual void irr::video::IVideoDriver::draw2DImage | ( | const video::ITexture * | texture,
|  | const core::rect< s32 > & | destRect,
|  | const core::rect< s32 > & | sourceRect,
|  | const core::rect< s32 > * | clipRect = `0`,
|  | const video::SColor *const | colors = `0`,
|  | bool | useAlphaChannelOfTexture = `false` |
| ) |  |  | `[pure virtual]`

Draws a part of the texture into the rectangle. Note that colors must be an array of 4 colors if used.

Suggested and first implemented by zola.

Parameters:

  | texture | The texture to draw from
  | destRect | The rectangle to draw into
  | sourceRect | The rectangle denoting a part of the texture
  | clipRect | Clips the destination rectangle (may be 0)
  | colors | Array of 4 colors denoting the color values of the corners of the destRect
  | useAlphaChannelOfTexture | True if alpha channel will be blended.

virtual void irr::video::IVideoDriver::draw2DImage | ( | const video::ITexture * | texture,
|  | const core::position2d< s32 > & | destPos,
|  | const core::rect< s32 > & | sourceRect,
|  | const core::rect< s32 > * | clipRect = `0`,
|  | SColor | color = `SColor(255, 255, 255, 255)`,
|  | bool | useAlphaChannelOfTexture = `false` |
| ) |  |  | `[pure virtual]`

Draws a 2d image using a color.

(if color is other than Color(255,255,255,255)) and the alpha channel of the texture.

Parameters:

  | texture | Texture to be drawn.
  | destPos | Upper left 2d destination position where the image will be drawn.
  | sourceRect | Source rectangle in the image.
  | clipRect | Pointer to rectangle on the screen where the image is clipped to. If this pointer is NULL the image is not clipped.
  | color | Color with which the image is drawn. If the color equals Color(255,255,255,255) it is ignored. Note that the alpha component is used: If alpha is other than 255, the image will be transparent.
  | useAlphaChannelOfTexture,: | If true, the alpha channel of the texture is used to draw the image.

virtual void irr::video::IVideoDriver::draw2DImage | ( | const video::ITexture * | texture,
|  | const core::position2d< s32 > & | destPos |
| ) |  |  | `[pure virtual]`

Draws a 2d image without any special effects.

Parameters:

  | texture | Pointer to texture to use.
  | destPos | Upper left 2d destination position where the image will be drawn.

virtual void irr::video::IVideoDriver::draw2DImageBatch | ( | const video::ITexture * | texture,
|  | const core::array< core::position2d< s32 > > & | positions,
|  | const core::array< core::rect< s32 > > & | sourceRects,
|  | const core::rect< s32 > * | clipRect = `0`,
|  | SColor | color = `SColor(255, 255, 255, 255)`,
|  | bool | useAlphaChannelOfTexture = `false` |
| ) |  |  | `[pure virtual]`

Draws a set of 2d images, using a color and the alpha channel of the texture.

All drawings are clipped against clipRect (if != 0). The subtextures are defined by the array of sourceRects and are positioned using the array of positions.

Parameters:

  | texture | Texture to be drawn.
  | pos | Array of upper left 2d destinations where the images will be drawn.
  | sourceRects | Source rectangles of the image.
  | clipRect | Pointer to rectangle on the screen where the images are clipped to. If this pointer is 0 then the image is not clipped.
  | color | Color with which the image is drawn. Note that the alpha component is used. If alpha is other than 255, the image will be transparent.
  | useAlphaChannelOfTexture,: | If true, the alpha channel of the texture is used to draw the image.

virtual void irr::video::IVideoDriver::draw2DImageBatch | ( | const video::ITexture * | texture,
|  | const core::position2d< s32 > & | pos,
|  | const core::array< core::rect< s32 > > & | sourceRects,
|  | const core::array< s32 > & | indices,
|  | s32 | kerningWidth = `0`,
|  | const core::rect< s32 > * | clipRect = `0`,
|  | SColor | color = `SColor(255, 255, 255, 255)`,
|  | bool | useAlphaChannelOfTexture = `false` |
| ) |  |  | `[pure virtual]`

Draws a set of 2d images, using a color and the alpha channel of the texture.

The images are drawn beginning at pos and concatenated in one line. All drawings are clipped against clipRect (if != 0). The subtextures are defined by the array of sourceRects and are chosen by the indices given.

Parameters:

  | texture | Texture to be drawn.
  | pos | Upper left 2d destination position where the image will be drawn.
  | sourceRects | Source rectangles of the image.
  | indices | List of indices which choose the actual rectangle used each time.
  | kerningWidth | Offset to Position on X
  | clipRect | Pointer to rectangle on the screen where the image is clipped to. If this pointer is 0 then the image is not clipped.
  | color | Color with which the image is drawn. Note that the alpha component is used. If alpha is other than 255, the image will be transparent.
  | useAlphaChannelOfTexture,: | If true, the alpha channel of the texture is used to draw the image.

virtual void irr::video::IVideoDriver::draw2DLine | ( | const core::position2d< s32 > & | start,
|  | const core::position2d< s32 > & | end,
|  | SColor | color = `SColor(255, 255, 255, 255)` |
| ) |  |  | `[pure virtual]`

Draws a 2d line.

Parameters:

  | start | Screen coordinates of the start of the line in pixels.
  | end | Screen coordinates of the start of the line in pixels.
  | color | Color of the line to draw.

virtual void irr::video::IVideoDriver::draw2DPolygon | ( | core::position2d< s32 > | center,
|  | f32 | radius,
|  | video::SColor | color = `SColor(100, 255, 255, 255)`,
|  | s32 | vertexCount = `10` |
| ) |  |  | `[pure virtual]`

Draws a non filled concyclic regular 2d polyon.

This method can be used to draw circles, but also triangles, tetragons, pentagons, hexagons, heptagons, octagons, enneagons, decagons, hendecagons, dodecagon, triskaidecagons, etc. I think you'll got it now. And all this by simply specifying the vertex count. Welcome to the wonders of geometry.

Parameters:

  | center | Position of center of circle (pixels).
  | radius | Radius of circle in pixels.
  | color | Color of the circle.
  | vertexCount | Amount of vertices of the polygon. Specify 2 to draw a line, 3 to draw a triangle, 4 for tetragons and a lot (>10) for nearly a circle.

virtual void irr::video::IVideoDriver::draw2DRectangle | ( | const core::rect< s32 > & | pos,
|  | SColor | colorLeftUp,
|  | SColor | colorRightUp,
|  | SColor | colorLeftDown,
|  | SColor | colorRightDown,
|  | const core::rect< s32 > * | clip = `0` |
| ) |  |  | `[pure virtual]`

Draws a 2d rectangle with a gradient.

Parameters:

  | colorLeftUp | Color of the upper left corner to draw. The alpha component will not be ignored and specifies how transparent the rectangle will be.
  | colorRightUp | Color of the upper right corner to draw. The alpha component will not be ignored and specifies how transparent the rectangle will be.
  | colorLeftDown | Color of the lower left corner to draw. The alpha component will not be ignored and specifies how transparent the rectangle will be.
  | colorRightDown | Color of the lower right corner to draw. The alpha component will not be ignored and specifies how transparent the rectangle will be.
  | pos | Position of the rectangle.
  | clip | Pointer to rectangle against which the rectangle will be clipped. If the pointer is null, no clipping will be performed.

virtual void irr::video::IVideoDriver::draw2DRectangle | ( | SColor | color,
|  | const core::rect< s32 > & | pos,
|  | const core::rect< s32 > * | clip = `0` |
| ) |  |  | `[pure virtual]`

Draws a 2d rectangle.

Parameters:

  | color | Color of the rectangle to draw. The alpha component will not be ignored and specifies how transparent the rectangle will be.
  | pos | Position of the rectangle.
  | clip | Pointer to rectangle against which the rectangle will be clipped. If the pointer is null, no clipping will be performed.

virtual void irr::video::IVideoDriver::draw2DRectangleOutline | ( | const core::recti & | pos,
|  | SColor | color = `SColor(255, 255, 255, 255)` |
| ) |  |  | `[pure virtual]`

Draws the outline of a 2D rectangle.

Parameters:

  | pos | Position of the rectangle.
  | color | Color of the rectangle to draw. The alpha component specifies how transparent the rectangle outline will be.

virtual void irr::video::IVideoDriver::draw2DVertexPrimitiveList | ( | const void * | vertices,
|  | u32 | vertexCount,
|  | const void * | indexList,
|  | u32 | primCount,
|  | E_VERTEX_TYPE | vType = `EVT_STANDARD`,
|  | scene::E_PRIMITIVE_TYPE | pType = `scene::EPT_TRIANGLES`,
|  | E_INDEX_TYPE | iType = `EIT_16BIT` |
| ) |  |  | `[pure virtual]`

Draws a vertex primitive list in 2d.

Compared to the general (3d) version of this method, this one sets up a 2d render mode, and uses only x and y of vectors. Note that, depending on the index type, some vertices might be not accessible through the index list. The limit is at 65535 vertices for 16bit indices. Please note that currently not all primitives are available for all drivers, and some might be emulated via triangle renders. This function is not available for the sw drivers.

Parameters:

  | vertices | Pointer to array of vertices.
  | vertexCount | Amount of vertices in the array.
  | indexList | Pointer to array of indices. These define the vertices used for each primitive. Depending on the pType, indices are interpreted as single objects (for point like primitives), pairs (for lines), triplets (for triangles), or quads.
  | primCount | Amount of Primitives
  | vType | Vertex type, e.g. video::EVT_STANDARD for S3DVertex.
  | pType | Primitive type, e.g. scene::EPT_TRIANGLE_FAN for a triangle fan.
  | iType | Index type, e.g. video::EIT_16BIT for 16bit indices.

virtual void irr::video::IVideoDriver::draw3DBox | ( | const core::aabbox3d< f32 > & | box,
|  | SColor | color = `SColor(255, 255, 255, 255)` |
| ) |  |  | `[pure virtual]`

Draws a 3d axis aligned box.

This method simply calls draw3DLine for the edges of the box. Note that the box is drawn using the current transformation matrix and material. So if you need to draw it independently of the current transformation, use

                    driver->setMaterial(someMaterial);
                    driver->setTransform(video::ETS_WORLD, core::IdentityMatrix);

for some properly set up material before drawing the box.

Parameters:

  | box | The axis aligned box to draw
  | color | Color to use while drawing the box.

virtual void irr::video::IVideoDriver::draw3DLine | ( | const core::vector3df & | start,
|  | const core::vector3df & | end,
|  | SColor | color = `SColor(255, 255, 255, 255)` |
| ) |  |  | `[pure virtual]`

Draws a 3d line.

For some implementations, this method simply calls drawVertexPrimitiveList for some triangles. Note that the line is drawn using the current transformation matrix and material. So if you need to draw the 3D line independently of the current transformation, use

                    driver->setMaterial(someMaterial);
                    driver->setTransform(video::ETS_WORLD, core::IdentityMatrix);

for some properly set up material before drawing the line. Some drivers support line thickness set in the material.

Parameters:

  | start | Start of the 3d line.
  | end | End of the 3d line.
  | color | Color of the line.

virtual void irr::video::IVideoDriver::draw3DTriangle | ( | const core::triangle3df & | triangle,
|  | SColor | color = `SColor(255, 255, 255, 255)` |
| ) |  |  | `[pure virtual]`

Draws a 3d triangle.

This method calls drawVertexPrimitiveList for some triangles. This method works with all drivers because it simply calls drawVertexPrimitiveList, but it is hence not very fast. Note that the triangle is drawn using the current transformation matrix and material. So if you need to draw it independently of the current transformation, use

                    driver->setMaterial(someMaterial);
                    driver->setTransform(video::ETS_WORLD, core::IdentityMatrix);

for some properly set up material before drawing the triangle.

Parameters:

  | triangle | The triangle to draw.
  | color | Color of the line.

virtual void irr::video::IVideoDriver::drawIndexedTriangleFan | ( | const S3DVertex2TCoords * | vertices,
|  | u32 | vertexCount,
|  | const u16 * | indexList,
|  | u32 | triangleCount |
| ) |  |  | `[pure virtual]`

Draws an indexed triangle fan.

Note that there may be at maximum 65536 vertices, because the index list is an array of 16 bit values each with a maximum value of 65536. If there are more than 65536 vertices in the list, results of this operation are not defined.

Parameters:

  | vertices | Pointer to array of vertices.
  | vertexCount | Amount of vertices in the array.
  | indexList | Pointer to array of indices.
  | triangleCount | Amount of Triangles. Usually amount of indices - 2.

virtual void irr::video::IVideoDriver::drawIndexedTriangleFan | ( | const S3DVertex * | vertices,
|  | u32 | vertexCount,
|  | const u16 * | indexList,
|  | u32 | triangleCount |
| ) |  |  | `[pure virtual]`

Draws an indexed triangle fan.

Note that there may be at maximum 65536 vertices, because the index list is an array of 16 bit values each with a maximum value of 65536. If there are more than 65536 vertices in the list, results of this operation are not defined.

Parameters:

  | vertices | Pointer to array of vertices.
  | vertexCount | Amount of vertices in the array.
  | indexList | Pointer to array of indices.
  | triangleCount | Amount of Triangles. Usually amount of indices - 2.

virtual void irr::video::IVideoDriver::drawIndexedTriangleList | ( | const S3DVertexTangents * | vertices,
|  | u32 | vertexCount,
|  | const u16 * | indexList,
|  | u32 | triangleCount |
| ) |  |  | `[pure virtual]`

Draws an indexed triangle list.

Note that there may be at maximum 65536 vertices, because the index list is an array of 16 bit values each with a maximum value of 65536. If there are more than 65536 vertices in the list, results of this operation are not defined.

Parameters:

  | vertices | Pointer to array of vertices.
  | vertexCount | Amount of vertices in the array.
  | indexList | Pointer to array of indices.
  | triangleCount | Amount of Triangles. Usually amount of indices / 3.

virtual void irr::video::IVideoDriver::drawIndexedTriangleList | ( | const S3DVertex2TCoords * | vertices,
|  | u32 | vertexCount,
|  | const u16 * | indexList,
|  | u32 | triangleCount |
| ) |  |  | `[pure virtual]`

Draws an indexed triangle list.

Note that there may be at maximum 65536 vertices, because the index list is an array of 16 bit values each with a maximum value of 65536. If there are more than 65536 vertices in the list, results of this operation are not defined.

Parameters:

  | vertices | Pointer to array of vertices.
  | vertexCount | Amount of vertices in the array.
  | indexList | Pointer to array of indices.
  | triangleCount | Amount of Triangles. Usually amount of indices / 3.

virtual void irr::video::IVideoDriver::drawIndexedTriangleList | ( | const S3DVertex * | vertices,
|  | u32 | vertexCount,
|  | const u16 * | indexList,
|  | u32 | triangleCount |
| ) |  |  | `[pure virtual]`

Draws an indexed triangle list.

Note that there may be at maximum 65536 vertices, because the index list is an array of 16 bit values each with a maximum value of 65536. If there are more than 65536 vertices in the list, results of this operation are not defined.

Parameters:

  | vertices | Pointer to array of vertices.
  | vertexCount | Amount of vertices in the array.
  | indexList | Pointer to array of indices.
  | triangleCount | Amount of Triangles. Usually amount of indices / 3.

virtual void irr::video::IVideoDriver::drawMeshBuffer | ( | const scene::IMeshBuffer * | mb | ) | `[pure virtual]`

Draws a mesh buffer.

Parameters:

  | mb | Buffer to draw;

virtual void irr::video::IVideoDriver::drawPixel | ( | u32 | x,
|  | u32 | y,
|  | const SColor & | color |
| ) |  |  | `[pure virtual]`

Draws a pixel.

Parameters:

  | x | The x-position of the pixel.
  | y | The y-position of the pixel.
  | color | Color of the pixel to draw.

virtual void irr::video::IVideoDriver::drawStencilShadow | ( | bool | clearStencilBuffer = `false`,
|  | video::SColor | leftUpEdge = `video::SColor(255, 0, 0, 0)`,
|  | video::SColor | rightUpEdge = `video::SColor(255, 0, 0, 0)`,
|  | video::SColor | leftDownEdge = `video::SColor(255, 0, 0, 0)`,
|  | video::SColor | rightDownEdge = `video::SColor(255, 0, 0, 0)` |
| ) |  |  | `[pure virtual]`

Fills the stencil shadow with color.

After the shadow volume has been drawn into the stencil buffer using IVideoDriver::drawStencilShadowVolume(), use this to draw the color of the shadow. Please note that the code for the opengl version of the method is based on free code sent in by Philipp Dortmann, lots of thanks go to him!

Parameters:

  | clearStencilBuffer | Set this to false, if you want to draw every shadow with the same color, and only want to call drawStencilShadow() once after all shadow volumes have been drawn. Set this to true, if you want to paint every shadow with its own color.
  | leftUpEdge | Color of the shadow in the upper left corner of screen.
  | rightUpEdge | Color of the shadow in the upper right corner of screen.
  | leftDownEdge | Color of the shadow in the lower left corner of screen.
  | rightDownEdge | Color of the shadow in the lower right corner of screen.

virtual void irr::video::IVideoDriver::drawStencilShadowVolume | ( | const core::vector3df * | triangles,
|  | s32 | count,
|  | bool | zfail = `true` |
| ) |  |  | `[pure virtual]`

Draws a shadow volume into the stencil buffer.

To draw a stencil shadow, do this: First, draw all geometry. Then use this method, to draw the shadow volume. Then, use IVideoDriver::drawStencilShadow() to visualize the shadow. Please note that the code for the opengl version of the method is based on free code sent in by Philipp Dortmann, lots of thanks go to him!

Parameters:

  | triangles | Pointer to array of 3d vectors, specifying the shadow volume.
  | count | Amount of triangles in the array.
  | zfail | If set to true, zfail method is used, otherwise zpass.

virtual void irr::video::IVideoDriver::drawVertexPrimitiveList | ( | const void * | vertices,
|  | u32 | vertexCount,
|  | const void * | indexList,
|  | u32 | primCount,
|  | E_VERTEX_TYPE | vType = `EVT_STANDARD`,
|  | scene::E_PRIMITIVE_TYPE | pType = `scene::EPT_TRIANGLES`,
|  | E_INDEX_TYPE | iType = `EIT_16BIT` |
| ) |  |  | `[pure virtual]`

Draws a vertex primitive list.

Note that, depending on the index type, some vertices might be not accessible through the index list. The limit is at 65535 vertices for 16bit indices. Please note that currently not all primitives are available for all drivers, and some might be emulated via triangle renders.

Parameters:

  | vertices | Pointer to array of vertices.
  | vertexCount | Amount of vertices in the array.
  | indexList | Pointer to array of indices. These define the vertices used for each primitive. Depending on the pType, indices are interpreted as single objects (for point like primitives), pairs (for lines), triplets (for triangles), or quads.
  | primCount | Amount of Primitives
  | vType | Vertex type, e.g. video::EVT_STANDARD for S3DVertex.
  | pType | Primitive type, e.g. scene::EPT_TRIANGLE_FAN for a triangle fan.
  | iType | Index type, e.g. video::EIT_16BIT for 16bit indices.

virtual void irr::video::IVideoDriver::enableClipPlane | ( | u32 | index,
|  | bool | enable |
| ) |  |  | `[pure virtual]`

Enable or disable a clipping plane.

There are at least 6 clipping planes available for the user to set at will.

Parameters:

  | index | The plane index. Must be between 0 and MaxUserClipPlanes.
  | enable | If true, enable the clipping plane else disable it.

virtual bool irr::video::IVideoDriver::endScene | ( |  | ) | `[pure virtual]`

Presents the rendered image to the screen.

Applications must call this method after performing any rendering.

Returns:
  False if failed and true if succeeded.

virtual void irr::video::IVideoDriver::fillMaterialStructureFromAttributes | ( | video::SMaterial & | outMaterial,
|  | io::IAttributes * | attributes |
| ) |  |  | `[pure virtual]`

Fills an SMaterial structure from attributes.

Please note that for setting material types of the material, the video driver will need to query the material renderers for their names, so all non built-in materials must have been created before calling this method.

Parameters:

  | outMaterial | The material to set the properties for.
  | attributes | The attributes to read from.

virtual video::ITexture* irr::video::IVideoDriver::findTexture | ( | const io::path & | filename | ) | `[pure virtual]`

Check if the image is already loaded.

Works similar to getTexture(), but does not load the texture if it is not currently loaded.

Parameters:

  | filename | Name of the texture.

Returns:
  Pointer to loaded texture, or 0 if not found.

virtual ECOLOR_FORMAT irr::video::IVideoDriver::getColorFormat | ( |  | ) | const`[pure virtual]`

Get the current color format of the color buffer.

Returns:
  Color format of the color buffer.

virtual const core::dimension2d<u32>& irr::video::IVideoDriver::getCurrentRenderTargetSize | ( |  | ) | const`[pure virtual]`

Get the size of the current render target.

This method will return the screen size if the driver doesn't support render to texture, or if the current render target is the screen.

Returns:
  Size of render target or screen/window

virtual E_DRIVER_TYPE irr::video::IVideoDriver::getDriverType | ( |  | ) | const`[pure virtual]`

Get type of video driver.

Returns:
  Type of driver.

virtual const SLight& irr::video::IVideoDriver::getDynamicLight | ( | u32 | idx | ) | const`[pure virtual]`

Returns light data which was previously set by IVideoDriver::addDynamicLight().

Parameters:

  | idx | Zero based index of the light. Must be 0 or greater and smaller than IVideoDriver()getDynamicLightCount.

Returns:
  Light data.

virtual u32 irr::video::IVideoDriver::getDynamicLightCount | ( |  | ) | const`[pure virtual]`

Returns amount of dynamic lights currently set.

Returns:
  Amount of dynamic lights currently set

virtual const SExposedVideoData& irr::video::IVideoDriver::getExposedVideoData | ( |  | ) | `[pure virtual]`

Returns driver and operating system specific data about the IVideoDriver.

This method should only be used if the engine should be extended without having to modify the source of the engine.

Returns:
  Collection of device dependent pointers.

virtual s32 irr::video::IVideoDriver::getFPS | ( |  | ) | const`[pure virtual]`

Returns current frames per second value.

This value is updated approximately every 1.5 seconds and is only intended to provide a rough guide to the average frame rate. It is not suitable for use in performing timing calculations or framerate independent movement.

Returns:
  Approximate amount of frames per second drawn.

virtual IGPUProgrammingServices* irr::video::IVideoDriver::getGPUProgrammingServices | ( |  | ) | `[pure virtual]`

Gets the IGPUProgrammingServices interface.

Returns:
  Pointer to the IGPUProgrammingServices. Returns 0 if the video driver does not support this. For example the Software driver and the Null driver will always return 0.

virtual IImageLoader* irr::video::IVideoDriver::getImageLoader | ( | u32 | n | ) | `[pure virtual]`

Retrieve the given image loader.

Parameters:

  | n | The index of the loader to retrieve. This parameter is an 0-based array index.

Returns:
  A pointer to the specified loader, 0 if the index is uncorrect.

virtual u32 irr::video::IVideoDriver::getImageLoaderCount | ( |  | ) | const`[pure virtual]`

Retrieve the number of image loaders.

Returns:
  Number of image loaders

virtual IImageWriter* irr::video::IVideoDriver::getImageWriter | ( | u32 | n | ) | `[pure virtual]`

Retrieve the given image writer.

Parameters:

  | n | The index of the writer to retrieve. This parameter is an 0-based array index.

Returns:
  A pointer to the specified writer, 0 if the index is uncorrect.

virtual u32 irr::video::IVideoDriver::getImageWriterCount | ( |  | ) | const`[pure virtual]`

Retrieve the number of image writers.

Returns:
  Number of image writers

virtual IMaterialRenderer* irr::video::IVideoDriver::getMaterialRenderer | ( | u32 | idx | ) | `[pure virtual]`

Get access to a material renderer by index.

Parameters:

  | idx | Id of the material renderer. Can be a value of the E_MATERIAL_TYPE enum or a value which was returned by addMaterialRenderer().

Returns:
  Pointer to material renderer or null if not existing.

virtual u32 irr::video::IVideoDriver::getMaterialRendererCount | ( |  | ) | const`[pure virtual]`

Get amount of currently available material renderers.

Returns:
  Amount of currently available material renderers.

virtual const c8* irr::video::IVideoDriver::getMaterialRendererName | ( | u32 | idx | ) | const`[pure virtual]`

Get name of a material renderer.

This string can, e.g., be used to test if a specific renderer already has been registered/created, or use this string to store data about materials: This returned name will be also used when serializing materials.

Parameters:

  | idx | Id of the material renderer. Can be a value of the E_MATERIAL_TYPE enum or a value which was returned by addMaterialRenderer().

Returns:
  String with the name of the renderer, or 0 if not exisiting

virtual u32 irr::video::IVideoDriver::getMaximalDynamicLightAmount | ( |  | ) | const`[pure virtual]`

Returns the maximal amount of dynamic lights the device can handle.

Returns:
  Maximal amount of dynamic lights.

virtual u32 irr::video::IVideoDriver::getMaximalPrimitiveCount | ( |  | ) | const`[pure virtual]`

Returns the maximum amount of primitives.

(mostly vertices) which the device is able to render with one drawVertexPrimitiveList call.

Returns:
  Maximum amount of primitives.

virtual scene::IMeshManipulator* irr::video::IVideoDriver::getMeshManipulator | ( |  | ) | `[pure virtual]`

Returns a pointer to the mesh manipulator.

virtual const wchar_t* irr::video::IVideoDriver::getName | ( |  | ) | const`[pure virtual]`

Gets name of this video driver.

Returns:
  Returns the name of the video driver, e.g. in case of the Direct3D8 driver, it would return "Direct3D 8.1".

virtual SOverrideMaterial& irr::video::IVideoDriver::getOverrideMaterial | ( |  | ) | `[pure virtual]`

Get the global Material, which might override local materials.

Depending on the enable flags, values from this Material are used to override those of local materials of some meshbuffer being rendered.

Returns:
  Reference to the Override Material.

virtual u32 irr::video::IVideoDriver::getPrimitiveCountDrawn | ( | u32 | mode = `0` | ) | const`[pure virtual]`

Returns amount of primitives (mostly triangles) which were drawn in the last frame.

Together with getFPS() very useful method for statistics.

Parameters:

  | mode | Defines if the primitives drawn are accumulated or counted per frame.

Returns:
  Amount of primitives drawn in the last frame.

virtual const core::dimension2d<u32>& irr::video::IVideoDriver::getScreenSize | ( |  | ) | const`[pure virtual]`

Get the size of the screen or render window.

Returns:
  Size of screen or render window.

virtual ITexture* irr::video::IVideoDriver::getTexture | ( | io::IReadFile * | file | ) | `[pure virtual]`

Get access to a named texture.

Loads the texture from disk if it is not already loaded and generates mipmap levels if desired. Texture loading can be influenced using the setTextureCreationFlag() method. The texture can be in several imageformats, such as BMP, JPG, TGA, PCX, PNG, and PSD.

Parameters:

  | file | Pointer to an already opened file.

Returns:
  Pointer to the texture, or 0 if the texture could not be loaded. This pointer should not be dropped. See IReferenceCounted::drop() for more information.

virtual ITexture* irr::video::IVideoDriver::getTexture | ( | const io::path & | filename | ) | `[pure virtual]`

Get access to a named texture.

Loads the texture from disk if it is not already loaded and generates mipmap levels if desired. Texture loading can be influenced using the setTextureCreationFlag() method. The texture can be in several imageformats, such as BMP, JPG, TGA, PCX, PNG, and PSD.

Parameters:

  | filename | Filename of the texture to be loaded.

Returns:
  Pointer to the texture, or 0 if the texture could not be loaded. This pointer should not be dropped. See IReferenceCounted::drop() for more information.

Referenced by irr::scene::quake3::getTextures().

virtual ITexture* irr::video::IVideoDriver::getTextureByIndex | ( | u32 | index | ) | `[pure virtual]`

Returns a texture by index.

Parameters:

  | index,: | Index of the texture, must be smaller than getTextureCount() Please note that this index might change when adding or removing textures

Returns:
  Pointer to the texture, or 0 if the texture was not set or index is out of bounds. This pointer should not be dropped. See IReferenceCounted::drop() for more information.

virtual u32 irr::video::IVideoDriver::getTextureCount | ( |  | ) | const`[pure virtual]`

Returns amount of textures currently loaded.

Returns:
  Amount of textures currently loaded

virtual bool irr::video::IVideoDriver::getTextureCreationFlag | ( | E_TEXTURE_CREATION_FLAG | flag | ) | const`[pure virtual]`

Returns if a texture creation flag is enabled or disabled.

You can change this value using setTextureCreationMode().

Parameters:

  | flag | Texture creation flag.

Returns:
  The current texture creation mode.

virtual const core::matrix4& irr::video::IVideoDriver::getTransform | ( | E_TRANSFORMATION_STATE | state | ) | const`[pure virtual]`

Returns the transformation set by setTransform.

Parameters:

  | state | Transformation type to query

Returns:
  Matrix describing the transformation.

virtual core::stringc irr::video::IVideoDriver::getVendorInfo | ( |  | ) | `[pure virtual]`

Returns the graphics card vendor name.

virtual const core::rect<s32>& irr::video::IVideoDriver::getViewPort | ( |  | ) | const`[pure virtual]`

Gets the area of the current viewport.

Returns:
  Rectangle of the current viewport.

virtual void irr::video::IVideoDriver::makeColorKeyTexture | ( | video::ITexture * | texture,
|  | core::position2d< s32 > | colorKeyPixelPos,
|  | bool | zeroTexels = `false` |
| ) |  |  | const`[pure virtual]`

Sets a boolean alpha channel on the texture based on the color at a position.

This makes the texture fully transparent at the texels where the color key can be found when using for example draw2DImage with useAlphachannel==true. The alpha of other texels is not modified.

Parameters:

  | texture | Texture whose alpha channel is modified.
  | colorKeyPixelPos | Position of a pixel with the color key color. Every texel with this color will become fully transparent as described above.
  | zeroTexels |

Deprecated:
  If set to true, then any texels that match the color key will have their color, as well as their alpha, set to zero (i.e. black). This behaviour matches the legacy (buggy) behaviour prior to release 1.5 and is provided for backwards compatibility only.

virtual void irr::video::IVideoDriver::makeColorKeyTexture | ( | video::ITexture * | texture,
|  | video::SColor | color,
|  | bool | zeroTexels = `false` |
| ) |  |  | const`[pure virtual]`

Sets a boolean alpha channel on the texture based on a color key.

This makes the texture fully transparent at the texels where this color key can be found when using for example draw2DImage with useAlphachannel==true. The alpha of other texels is not modified.

Parameters:

  | texture | Texture whose alpha channel is modified.
  | color | Color key color. Every texel with this color will become fully transparent as described above. Please note that the colors of a texture may be converted when loading it, so the color values may not be exactly the same in the engine and for example in picture edit programs. To avoid this problem, you could use the makeColorKeyTexture method, which takes the position of a pixel instead a color value.
  | zeroTexels |

Deprecated:
  If set to true, then any texels that match the color key will have their color, as well as their alpha, set to zero (i.e. black). This behaviour matches the legacy (buggy) behaviour prior to release 1.5 and is provided for backwards compatibility only.

virtual void irr::video::IVideoDriver::makeNormalMapTexture | ( | video::ITexture * | texture,
|  | f32 | amplitude = `1.0f` |
| ) |  |  | const`[pure virtual]`

Creates a normal map from a height map texture.

If the target texture has 32 bit, the height value is stored in the alpha component of the texture as addition. This value is used by the video::EMT_PARALLAX_MAP_SOLID material and similar materials.

Parameters:

  | texture | Texture whose alpha channel is modified.
  | amplitude | Constant value by which the height information is multiplied.

virtual void irr::video::IVideoDriver::OnResize | ( | const core::dimension2d< u32 > & | size | ) | `[pure virtual]`

Event handler for resize events. Only used by the engine internally.

Used to notify the driver that the window was resized. Usually, there is no need to call this method.

virtual bool irr::video::IVideoDriver::queryFeature | ( | E_VIDEO_DRIVER_FEATURE | feature | ) | const`[pure virtual]`

Queries the features of the driver.

Returns true if a feature is available

Parameters:

  | feature | Feature to query.

Returns:
  True if the feature is available, false if not.

virtual void irr::video::IVideoDriver::removeAllHardwareBuffers | ( |  | ) | `[pure virtual]`

Remove all hardware buffers.

virtual void irr::video::IVideoDriver::removeAllTextures | ( |  | ) | `[pure virtual]`

Removes all textures from the texture cache and deletes them.

This method can free a lot of memory! Please note that after calling this, the pointer to the ITexture may no longer be valid, if it was not grabbed before by other parts of the engine for storing it longer. So it is a good idea to set all materials which are using this texture to 0 or another texture first.

virtual void irr::video::IVideoDriver::removeHardwareBuffer | ( | const scene::IMeshBuffer * | mb | ) | `[pure virtual]`

Remove hardware buffer.

virtual void irr::video::IVideoDriver::removeTexture | ( | ITexture * | texture | ) | `[pure virtual]`

Removes a texture from the texture cache and deletes it.

This method can free a lot of memory! Please note that after calling this, the pointer to the ITexture may no longer be valid, if it was not grabbed before by other parts of the engine for storing it longer. So it is a good idea to set all materials which are using this texture to 0 or another texture first.

Parameters:

  | texture | Texture to delete from the engine cache.

virtual void irr::video::IVideoDriver::renameTexture | ( | ITexture * | texture,
|  | const io::path & | newName |
| ) |  |  | `[pure virtual]`

Renames a texture.

Parameters:

  | texture | Pointer to the texture to rename.
  | newName | New name for the texture. This should be a unique name.

virtual void irr::video::IVideoDriver::setAllowZWriteOnTransparent | ( | bool | flag | ) | `[pure virtual]`

Only used by the engine internally.

Passes the global material flag AllowZWriteOnTransparent. Use the SceneManager attribute to set this value from your app.

Parameters:

  | flag | Default behavior is to disable ZWrite, i.e. false.

virtual void irr::video::IVideoDriver::setAmbientLight | ( | const SColorf & | color | ) | `[pure virtual]`

Only used by the engine internally.

The ambient color is set in the scene manager, see scene::ISceneManager::setAmbientLight().

Parameters:

  | color | New color of the ambient light.

virtual bool irr::video::IVideoDriver::setClipPlane | ( | u32 | index,
|  | const core::plane3df & | plane,
|  | bool | enable = `false` |
| ) |  |  | `[pure virtual]`

Set or unset a clipping plane.

There are at least 6 clipping planes available for the user to set at will.

Parameters:

  | index | The plane index. Must be between 0 and MaxUserClipPlanes.
  | plane | The plane itself.
  | enable | If true, enable the clipping plane else disable it.

Returns:
  True if the clipping plane is usable.

virtual void irr::video::IVideoDriver::setFog | ( | SColor | color = `SColor(0, 255, 255, 255)`,
|  | E_FOG_TYPE | fogType = `EFT_FOG_LINEAR`,
|  | f32 | start = `50.0f`,
|  | f32 | end = `100.0f`,
|  | f32 | density = `0.01f`,
|  | bool | pixelFog = `false`,
|  | bool | rangeFog = `false` |
| ) |  |  | `[pure virtual]`

Sets the fog mode.

These are global values attached to each 3d object rendered, which has the fog flag enabled in its material.

Parameters:

  | color | Color of the fog
  | fogType | Type of fog used
  | start | Only used in linear fog mode (linearFog=true). Specifies where fog starts.
  | end | Only used in linear fog mode (linearFog=true). Specifies where fog ends.
  | density | Only used in exponential fog mode (linearFog=false). Must be a value between 0 and 1.
  | pixelFog | Set this to false for vertex fog, and true if you want per-pixel fog.
  | rangeFog | Set this to true to enable range-based vertex fog. The distance from the viewer is used to compute the fog, not the z-coordinate. This is better, but slower. This might not be available with all drivers and fog settings.

virtual void irr::video::IVideoDriver::setMaterial | ( | const SMaterial & | material | ) | `[pure virtual]`

Sets a material.

All 3d drawing functions will draw geometry using this material thereafter.

Parameters:

  | material,: | Material to be used from now on.

virtual void irr::video::IVideoDriver::setMaterialRendererName | ( | s32 | idx,
|  | const c8 * | name |
| ) |  |  | `[pure virtual]`

Sets the name of a material renderer.

Will have no effect on built-in material renderers.

Parameters:

  | idx,: | Id of the material renderer. Can be a value of the E_MATERIAL_TYPE enum or a value which was returned by addMaterialRenderer().
  | name,: | New name of the material renderer.

virtual void irr::video::IVideoDriver::setMinHardwareBufferVertexCount | ( | u32 | count | ) | `[pure virtual]`

Set the minimum number of vertices for which a hw buffer will be created.

Parameters:

  | count | Number of vertices to set as minimum.

virtual bool irr::video::IVideoDriver::setRenderTarget | ( | E_RENDER_TARGET | target,
|  | bool | clearTarget = `true`,
|  | bool | clearZBuffer = `true`,
|  | SColor | color = `video::SColor(0, 0, 0, 0)` |
| ) |  |  | `[pure virtual]`

set or reset special render targets

This method enables access to special color buffers such as stereoscopic buffers or auxiliary buffers.

Parameters:

  | target | Enum value for the render target
  | clearTarget | Clears the target buffer with the color parameter
  | clearZBuffer | Clears the zBuffer of the rendertarget. Note that because the main frame buffer may share the zbuffer with the rendertarget, its zbuffer might be partially cleared too by this.
  | color | The background color for the render target.

Returns:
  True if sucessful and false if not.

virtual bool irr::video::IVideoDriver::setRenderTarget | ( | video::ITexture * | texture,
|  | bool | clearBackBuffer = `true`,
|  | bool | clearZBuffer = `true`,
|  | SColor | color = `video::SColor(0, 0, 0, 0)` |
| ) |  |  | `[pure virtual]`

Sets a new render target.

This will only work if the driver supports the EVDF_RENDER_TO_TARGET feature, which can be queried with queryFeature(). Usually, rendering to textures is done in this way:

                    // create render target
                    ITexture* target = driver->addRenderTargetTexture(core::dimension2d<u32>(128,128), "rtt1");

                    // ...

                    driver->setRenderTarget(target); // set render target
                    // .. draw stuff here
                    driver->setRenderTarget(0); // set previous render target

Please note that you cannot render 3D or 2D geometry with a render target as texture on it when you are rendering the scene into this render target at the same time. It is usually only possible to render into a texture between the IVideoDriver::beginScene() and endScene() method calls.

Parameters:

  | texture | New render target. Must be a texture created with IVideoDriver::addRenderTargetTexture(). If set to 0, it sets the previous render target which was set before the last setRenderTarget() call.
  | clearBackBuffer | Clears the backbuffer of the render target with the color parameter
  | clearZBuffer | Clears the zBuffer of the rendertarget. Note that because the frame buffer may share the zbuffer with the rendertarget, its zbuffer might be partially cleared too by this.
  | color | The background color for the render target.

Returns:
  True if sucessful and false if not.

virtual void irr::video::IVideoDriver::setTextureCreationFlag | ( | E_TEXTURE_CREATION_FLAG | flag,
|  | bool | enabled = `true` |
| ) |  |  | `[pure virtual]`

Enables or disables a texture creation flag.

These flags define how textures should be created. By changing this value, you can influence for example the speed of rendering a lot. But please note that the video drivers take this value only as recommendation. It could happen that you enable the ETCF_ALWAYS_16_BIT mode, but the driver still creates 32 bit textures.

Parameters:

  | flag | Texture creation flag.
  | enabled | Specifies if the given flag should be enabled or disabled.

virtual void irr::video::IVideoDriver::setTransform | ( | E_TRANSFORMATION_STATE | state,
|  | const core::matrix4 & | mat |
| ) |  |  | `[pure virtual]`

Sets transformation matrices.

Parameters:

  | state | Transformation type to be set, e.g. view, world, or projection.
  | mat | Matrix describing the transformation.

virtual void irr::video::IVideoDriver::setViewPort | ( | const core::rect< s32 > & | area | ) | `[pure virtual]`

Sets a new viewport.

Every rendering operation is done into this new area.

Parameters:

  | area,: | Rectangle defining the new area of rendering operations.

virtual void irr::video::IVideoDriver::turnLightOn | ( | s32 | lightIndex,
|  | bool | turnOn |
| ) |  |  | `[pure virtual]`

Turns a dynamic light on or off

Parameters:

  | lightIndex,: | the index returned by addDynamicLight
  | turnOn,: | true to turn the light on, false to turn it off

virtual bool irr::video::IVideoDriver::writeImageToFile | ( | IImage * | image,
|  | io::IWriteFile * | file,
|  | u32 | param = `0` |
| ) |  |  | `[pure virtual]`

Writes the provided image to a file.

Requires that there is a suitable image writer registered for writing the image.

Parameters:

  | image | Image to write.
  | file | An already open io::IWriteFile object. The name will be used to determine the appropriate image writer to use.
  | param | Control parameter for the backend (e.g. compression level).

Returns:
  True on successful write.

virtual bool irr::video::IVideoDriver::writeImageToFile | ( | IImage * | image,
|  | const io::path & | filename,
|  | u32 | param = `0` |
| ) |  |  | `[pure virtual]`

Writes the provided image to a file.

Requires that there is a suitable image writer registered for writing the image.

Parameters:

  | image | Image to write.
  | filename | Name of the file to write.
  | param | Control parameter for the backend (e.g. compression level).

Returns:
  True on successful write.

The documentation for this class was generated from the following file:

- IVideoDriver.h

| The Irrlicht Engine Documentation © 2003-2009 by Nikolaus Gebhardt. Generated on Sun Jan 10 09:24:19 2010 by Doxygen (1.5.6)